//"32CH Programmable Sequencer". On the basis of Arduino the controler. 
//The author of the program alexval2007, Asstoxa , Open_Pyro.  V6 (4.10.2010) 
//******************************************************************************************************
// История версий:
// 
// V6.1 (04.10.20010) Open_Pyro. alexval2007
// 0.1 убран баг с типом переменной   int i=0; заработало но выводит только первые 16битв регистры хотя в UART отдаёт весь массив
// 1. Изменен тип переменных: 
//     - там где число явно не будет выходит за предел 255 используется "unsigned char"
//     - изменен тип хранения данных "CueDelay[32]" времени задержки между запусками каналов с "int" 
//       (максимальное значение 32 768 или 32.8 сек задержки) на "unsigned long" которое возможно в 
//       в функции "delay()" (максимальное значение 4 294 967 296 или 4294967.2 сек задержки).
//
// 2. Из функции "void shiftOut(int myDataPin, int myClockPin, unsigned long myDataOut)" выкинул передаваемые     
//    параметры ножек "myDataPin" и "myClockPin", так как регистры у нас подключены на фиксированные ножки МК. 
//    Функция теперь имеет вид "void shiftOut( unsigned long myDataOut)", а выводы инициализируемый при старте 
//    процессора. Что ускоряет работу и уменьшает код.
//
// 3. "Подготавливаем регистр к приёму данных" и "Защелкиваем данные в регистре" перенесено в функцию
//    "void shiftOut( unsigned long myDataOut)".
//
// 4. Теперь выходы не работают постоянно в состоянии "1" а обнуляются перед запуском следующего канала.
//    Так же заработала временная задержка "Время импульса на воспламенители ххх мсек."
//
// 5. По тексту программы добавлены описания и пояснения, а тек же отформатирован код для лучшей читаемости.

  #define CueHIGH 50 // Время импульса на воспламенители ххх мсек. 
  
  #define Cue1 40    // Время задержки между запусками первого и следующего за ним канала в ххх мсек 
  #define Cue2 40    // !обязательно отнимите время импульса на воспламенители!!!!!!!!!!!!!!!!!!!!   
  #define Cue3 40    // Если Время импульса 100 мсек (0,1 сек) а следующий канал нужно запустит через 0,5 сек,
  #define Cue4 40    // то Cue1 должно иметь значение 400 мсек (500 мсек - 100 мсек = 400 мсек) 
  #define Cue5 40
  #define Cue6 40 
  #define Cue7 40
  #define Cue8 40
  #define Cue9 40
  #define Cue10 40
  #define Cue11 40
  #define Cue12 40 
  #define Cue13 40
  #define Cue14 40
  #define Cue15 40 
  #define Cue16 40
  #define Cue17 40
  #define Cue18 40
  #define Cue19 40
  #define Cue20 40
  #define Cue21 40
  #define Cue22 40
  #define Cue23 40
  #define Cue24 40
  #define Cue25 40
  #define Cue26 40
  #define Cue27 40
  #define Cue28 40
  #define Cue29 40
  #define Cue30 40
  #define Cue31 40
  #define Cue32 10   
//******************************************************************************************************  
  unsigned char dataPin  = 2;   // Подключаем вывод к DS of 74HC595 
  unsigned char latchPin = 3;   // Подключаем вывод к ST_CP of 74HC595 
  unsigned char clockPin = 4;   // Подключаем вывод к SH_CP of 74HC595 
  unsigned char BUTTON   = 19;  // Вход кнопки "старт"

//Обявляю переменные и массивы      
  unsigned long data = 0;       // Переменная состоит из 4 байт которые пишутся в 4-ре регистра
  unsigned char val = 0;        // Переменная состояния кнопки
  unsigned char y;              // Переменные циклов
  unsigned char pinState;
  int CueHIGH_delay = CueHIGH; //  Время импульса на воспламенители
  int CueDelay[32] = { Cue1,  Cue2,  Cue3,  Cue4,  Cue5,  Cue6,  Cue7,  Cue8,  Cue9,  Cue10, 
                                 Cue11, Cue12, Cue13, Cue14, Cue15, Cue16, Cue17, Cue18, Cue19, Cue20,
                                 Cue21, Cue22, Cue23, Cue24, Cue25, Cue26, Cue27, Cue28, Cue29, Cue30, 
                                 Cue31, Cue32}; //  Время задержки между запусками за вычетом времени
                                                //  импульса на воспламенители
//****************************************************************************************************** 
// Инициализация *************************************************************************************** 
  void setup(){ 
    pinMode(BUTTON , INPUT);    // Настраиваю Pin на ввод
    digitalWrite(BUTTON, HIGH); // Включаю подтягивающий резистор по входу к лог     
    pinMode(dataPin, OUTPUT);   // Настраиваем порты сдвигового регистра на вывод 
    pinMode(latchPin, OUTPUT);  
    pinMode(clockPin, OUTPUT); 
    digitalWrite(dataPin, 0);   // Обнуляем порты сдвигового регистра
    digitalWrite(latchPin, 0); 
    digitalWrite(clockPin, 0);
    Serial.begin(9600);         // Скорость обмена по UART 
    Serial.println("TEST HELLO");
    
    //********************************** 
    // Обнуление выходов регистров после запуска МК    
    shiftOut(0);               // Данные пишутся в регистр (все биты "0") 
    delay(50);
  } 
//****************************************************************************************************** 
// Основной цикл ***************************************************************************************
  void loop(){
    val = digitalRead(BUTTON); // Обработка состояния пускового входного сигнала
    if (val == LOW){ 
    //********************************************                  
      for (y=0; y<32; y++){
        data=(1<<y);           // пишем сюда очередную ножку
        Serial.println((CueHIGH_delay + CueDelay[y])); 
        shiftOut(data);        // Ставим ножку в единицу
        delay(CueHIGH_delay);  // Время импульса на воспламенители 
        shiftOut(0);           // Сбрасываем ножку 
        delay(CueDelay[y]);
      }         
    //*******************************************      
    }
    else{   
      delay(50);
      //  Обнуление регистров	
      shiftOut(0);               // Данные пишутся в регистр (все биты "0") 
   }
}  
//******************************************************************************************************
//Подпрограмма вывода на сдвиговый регистр ************************************************************* 
  void shiftOut(unsigned long myDataOut ){    
    digitalWrite(latchPin, 0);         // Подготавливаем регистр к приёму данных    
   int i=0;
    for (i=31; i>=0; i--){ 
      digitalWrite(clockPin, 0);
      if (myDataOut & (1<<i)){ 
      pinState= 1;
    }else{ 
      pinState= 0; 
    }   
        
      digitalWrite(dataPin, pinState); // Устанавливает pin данных в ВЫСОКИЙ или НИЗКОЕ в зависимости от pinState 
      digitalWrite(clockPin, 1);       // установить бит clock pin в лог 1 
    } 
    digitalWrite(clockPin, 0);         // остановить сдвиг 
    digitalWrite(dataPin, 0); 

    digitalWrite(latchPin, 1);         // Защелкиваем данные в регистре     
}
//******************************************************************************************************

